*** unix_ddll_drv.c	Mon Oct  8 10:35:23 2001
--- new_unix_ddll_drv.c	Wed Oct 16 09:42:14 2002
***************
*** 94,106 ****
   */
  void *ddll_sym(void *handle, char *func_name)
  {
- #if defined(HAVE_DLOPEN)
-     return dlsym(handle, func_name);
- #else
  #if defined(HAVE_MACH_O_DYLD_H)
      NSSymbol nssymbol = NSLookupSymbolInModule((NSModule*)handle,func_name);
      return nssymbol != NULL ? NSAddressOfSymbol(nssymbol) : NULL;
  #else
      dlopen_error = ERL_DLERR_NOT_AVAILABLE;
      return NULL;
  #endif
--- 94,106 ----
   */
  void *ddll_sym(void *handle, char *func_name)
  {
  #if defined(HAVE_MACH_O_DYLD_H)
      NSSymbol nssymbol = NSLookupSymbolInModule((NSModule*)handle,func_name);
      return nssymbol != NULL ? NSAddressOfSymbol(nssymbol) : NULL;
  #else
+ #if defined(HAVE_DLOPEN)
+     return dlsym(handle, func_name);
+ #else
      dlopen_error = ERL_DLERR_NOT_AVAILABLE;
      return NULL;
  #endif
***************
*** 113,124 ****
  int ddll_close(handle)
       void *handle;
  {
- #if defined(HAVE_DLOPEN)
-     return dlclose(handle);
- #else
  #if defined(HAVE_MACH_O_DYLD_H)
      return 0;
  #else
      dlopen_error = ERL_DLERR_NOT_AVAILABLE;
      return -1;
  #endif
--- 113,124 ----
  int ddll_close(handle)
       void *handle;
  {
  #if defined(HAVE_MACH_O_DYLD_H)
      return 0;
  #else
+ #if defined(HAVE_DLOPEN)
+     return dlclose(handle);
+ #else
      dlopen_error = ERL_DLERR_NOT_AVAILABLE;
      return -1;
  #endif
***************
*** 143,151 ****
  	    return "unknown error";
  	}
      }
- #ifdef HAVE_DLOPEN
-     msg = dlerror();
- #else
  #if defined(HAVE_MACH_O_DYLD_H)
      if (dyld_last_result != NSObjectFileImageSuccess) {
        switch (dyld_last_result) {
--- 143,148 ----
***************
*** 168,173 ****
--- 165,173 ----
  	}
        }
      }
+ #else
+ #if defined(HAVE_DLOPEN)
+     msg = dlerror();
  #endif
  #endif
      return msg ? msg : "no error";
